
10 REM**INTRODUCTORY TEXT**
20 CLEAR 100
30 PRINT CHR$(12);
40 FOR I=1 TO 12:PRINT CHR$(26);:NEXT
50 PRINT TAB(20);"COMPUTER SIMULATION"
60 PRINT:PRINT TAB(26);"OF THE"
70 PRINT:PRINT TAB(20);"SCHRODINGER EQUATION"
80 GOSUB 1600
90 FOR I=1 TO 12:PRINT CHR$(26);:NEXT
100 PRINT TAB(10);"SOLUTION OF THE SCHRODINGER EQUATION"
110 PRINT:PRINT TAB(20);"FOR THE DEUTERON"
120 GOSUB 1600
130 FOR I=1 TO 6:PRINT CHR$(26);:NEXT
140 PRINT TAB(9);"This program solves the Schrodinger equation"
150 PRINT
160 PRINT TAB(9);"for the deuteron assuming that the proton and"
170 PRINT
180 PRINT TAB(9);"neutron interact via a spherically symmetric"
190 PRINT
200 PRINT TAB(9);"rectangular potential energy well."
210 GOSUB 1600
220 FOR I=1 TO 6:PRINT CHR$(26);:NEXT
230 PRINT TAB(9);"In this study the interaction potential"
240 PRINT
250 PRINT TAB(9);"energy is assumed to be zero when the proton"
260 PRINT
270 PRINT TAB(9);"and neutron are separated by an infinite"
280 PRINT
290 PRINT TAB(9);"distance. You should therefore consider"
300 PRINT
310 PRINT TAB(9);"carefully whether to enter positive or"
320 PRINT
330 PRINT TAB(9);"negative values for inputs requested by"
340 PRINT
350 PRINT TAB(9);"the computer."
360 GOSUB 1600
370 FOR I=1 TO 6:PRINT CHR$(26);:NEXT
380 PRINT TAB(9);"The computer will automatically round off"
390 PRINT
400 PRINT TAB(9);"well depth values to one decimal place."
410 PRINT
420 PRINT TAB(9);"When requested you should enter the reduced"
430 PRINT
440 PRINT TAB(9);"mass of the deuteron correct to one decimal"
450 PRINT
460 PRINT TAB(9);"place."
470 GOSUB 1600
480 FOR I=1 TO 6:PRINT CHR$(26);:NEXT
490 PRINT TAB(9);"In this simulation the ground state wave"
500 PRINT
510 PRINT TAB(9);"function is ODD. The reason for this is"
520 PRINT
530 PRINT TAB(9);"explained in the student's workbook. Read"
540 PRINT
550 PRINT TAB(9);"the student's workbook and make sure that"
560 PRINT
570 PRINT TAB(9);"you understand what you have to do !"
580 GOSUB 1600
590 REM**MAIN PROGRAM**
600 PRINT:PRINT "Input well half-width in femtometres";
610 GOSUB 2400
620 W1=VAL(T1$)
630 W=W1/29
640 PRINT CHR$(17);
650 FOR I=1 TO 6:PRINT CHR$(26);:NEXT
660 PRINT "Input reduced mass in amu";
670 GOSUB 2600
680 M=INT(T2*10+0.5)/10
690 PRINT CHR$(17);
700 FOR I=1 TO 10:PRINT CHR$(26);:NEXT
710 PRINT "Input ground state energy in Mev";
720 GOSUB 2800
730 E1=VAL(T3$)
740 E=E1/0.0248
750 GOSUB 1600
760 PRINT
770 GOSUB 1800
780 PRINT CHR$(17);
790 FOR I=1 TO 4:PRINT CHR$(19);:NEXT
800 FOR I=1 TO 4:PRINT CHR$(26);:NEXT
810 PRINT "Label well depth in Mev";
820 GOSUB 3000
830 PRINT CHR$(17);
840 V1=VAL(T4$)
850 V1=INT(V1*10+0.5)/10
860 FOR I=1 TO 4:PRINT CHR$(19);:NEXT
870 FOR I=1 TO 4:PRINT CHR$(26);:NEXT
880 PRINT "Well depth=";V1;"Mev"
890 PRINT CHR$(17);
900 FOR I=1 TO 3:PRINT CHR$(19);:NEXT
910 FOR I=1 TO 25:PRINT CHR$(26);:NEXT
920 PRINT V1
930 V=V1/0.0248
940 A=0
950 S=30
960 D=W/10
970 REM**CALCULATION OF WAVE AMPLITUDE**
980 A=A+S*D/2
990 R=0
1000 IF R>5*W THEN 1140
1010 GOSUB 2100
1020 IF R>=W THEN 1070
1030 C=-M*(E-V)*A
1040 S=S+C*D
1050 A=A+S*D
1060 GOTO 1100
1070 C=-M*E*A
1080 S=S+C*D
1090 A=A+S*D
1100 R=R+D
1110 IF A>2 THEN 1140
1120 IF A<-2 THEN 1140
1130 GOTO 1000
1140 PRINT CHR$(17);
1150 FOR I=1 TO 31:PRINT CHR$(19);:NEXT
1160 FOR I=1 TO 4:PRINT CHR$(26);:NEXT
1170 PRINT "New well depth type 1,";
1180 PRINT CHR$(17);
1190 FOR I=1 TO 31:PRINT CHR$(19);:NEXT
1200 FOR I=1 TO 5:PRINT CHR$(26);:NEXT
1210 PRINT "New energy type 2";
1220 GOSUB 3200
1230 PRINT CHR$(12);
1240 E=VAL(T3$)/0.0248
1250 IF T5$="1" THEN 770
1260 GOSUB 1800
1270 FOR I=1 TO 3:PRINT CHR$(19);:NEXT
1280 FOR I=1 TO 25:PRINT CHR$(26);:NEXT
1290 PRINT V1
1300 PRINT CHR$(17);
1310 FOR I=1 TO 4:PRINT CHR$(19);:NEXT
1320 FOR I=1 TO 4:PRINT CHR$(26);:NEXT
1330 PRINT "Well depth=";V1;"Mev";
1340 PRINT CHR$(17);
1350 FOR I=1 TO 4:PRINT CHR$(19);:NEXT
1360 FOR I=1 TO 5:PRINT CHR$(26);:NEXT
1370 PRINT "Select new energy in Mev";
1380 GOSUB 3300
1390 E=VAL(T6$)/0.0248
1400 GOTO 940
1590 REM**SUBROUTINE TO TURN PAGES OF TEXT**
1600 PRINT CHR$(17);
1610 FOR I=1 TO 28:PRINT CHR$(26);:NEXT
1620 PRINT "Type 1 and press RETURN to proceed";
1630 INPUT T0$
1640 IF T0$="1" GOTO 1730
1650 PRINT CHR$(17);
1670 FOR I=1 TO 28:PRINT CHR$(26);:NEXT
1680 PRINT "                                            "
1690 PRINT CHR$(17);
1700 FOR I=1 TO 28:PRINT CHR$(26);:NEXT
1710 PRINT "YOU MUST TYPE 1 AND PRESS RETURN TO PROCEED";
1720 GOTO 1630
1730 PRINT CHR$(12);
1740 T0$="0"
1750 RETURN
1790 REM**SUBROUTINE TO PLOT AND LABEL WELL**
1800 PRINT CHR$(12)
1810 PRINT
1820 PRINT "    Well half-width=";W1;"femtometres";
1830 PRINT TAB(40);"Reduced mass=";M;"amu"
1840 PRINT "    Ground state energy=";E1;"Mev"
1850 FOR I=1 TO 61:POKE(-3903+I),151:NEXT
1860 FOR I=1 TO 61:POKE(-3519+I),151:NEXT
1870 FOR I=1 TO 61:POKE(-2175+I),151:NEXT
1880 FOR I=1 TO 27:POKE(-3903+(I*64)),162:NEXT
1890 FOR I=1 TO 27:POKE(-3842+(I*64)),162:NEXT
1900 POKE -3903,188:POKE -3842,189
1910 POKE -3519,180:POKE -3458,185
1920 POKE -2175,190:POKE -2114,191
1930 FOR X=1 TO 10:POKE(-2362+X),46:NEXT
1940 FOR Y=0 TO 15:POKE(-2351-(Y*64)),46:NEXT
1950 FOR X=1 TO 40:POKE(-3312+X),46:NEXT
1960 POKE -2298,48:POKE -2287,(48+W1)
1970 POKE -3323,48
1980 RETURN
2090 REM**SUBROUTINE TO PLOT DEUTERON WAVE FUNCTION**
2100 R1=R*10/W
2110 R1=INT(R1+0.5)
2120 A1=60-(A*30)
2130 A1=INT(A1+0.5)
2140 FOR Y=8 TO 120 STEP 8
2150 IF Y>=A1 GOTO 2170
2160 NEXT Y
2170 IF A1=Y THEN P=176
2180 IF A1=Y-1 THEN P=175
2190 IF A1=Y-2 THEN P=174
2200 IF A1=Y-3 THEN P=151
2210 IF A1=Y-4 THEN P=140
2220 IF A1=Y-5 THEN P=139
2230 IF A1=Y-6 THEN P=138
2240 IF A1=Y-7 THEN P=137
2250 POKE(-3386+(8*Y)+R1),P
2260 RETURN
2390 REM**SUBROUTINE TO VALIDATE DEUTERON WELL HALF-WIDTH**
2400 INPUT T1$
2410 PRINT CHR$(17);
2420 PRINT:PRINT "                                          "
2430 IF T1$="2" THEN 2470
2440 PRINT CHR$(17);
2450 PRINT:PRINT "THIS IS NOT THE WELL HALF-WIDTH. TRY AGAIN";
2460 GOTO 2400
2470 PRINT CHR$(12);
2480 PRINT:PRINT "Well half-width=";W1;"femtometres"
2490 RETURN
2590 REM**SUBROUTINE TO VALIDATE REDUCED MASS**
2600 INPUT T2$
2610 PRINT CHR$(17);
2620 FOR I=1 TO 6:PRINT CHR$(26);:NEXT
2630 PRINT "                                                "
2640 T2=VAL(T2$)
2650 IF T2>0.5 AND T2<0.504 THEN 2710
2660 IF T2$=".5" THEN 2710
2670 PRINT CHR$(17);
2680 FOR I=1 TO 6:PRINT CHR$(26);:NEXT
2690 PRINT "THIS IS NOT THE REDUCED MASS. TRY AGAIN";
2700 GOTO 2600
2710 PRINT CHR$(17);
2720 FOR I=1 TO 6:PRINT CHR$(26);:NEXT
2730 PRINT "Reduced mass=";T2;"amu"
2740 RETURN
2790 REM**SUBROUTINE TO VALIDATE DEUTERON BINDING ENERGY**
2800 INPUT T3$
2810 PRINT CHR$(17);
2820 FOR I=1 TO 10:PRINT CHR$(26);:NEXT
2830 PRINT "                                                "
2840 IF T3$="-2.22" THEN 2920
2850 IF VAL(T3$)>=0 THEN 2895
2860 PRINT CHR$(17);
2870 FOR I=1 TO 10:PRINT CHR$(26);:NEXT
2880 PRINT "THIS IS NOT THE BINDING ENERGY. TRY AGAIN";
2890 GOTO 2800
2895 FOR I=1 TO 10:PRINT CHR$(26);:NEXT
2900 PRINT "ENTER A NEGATIVE NUMBER";
2910 GOTO 2800
2920 PRINT CHR$(17);
2930 FOR I=1 TO 10:PRINT CHR$(26);:NEXT
2940 PRINT "Ground state energy=";T3$;"Mev"
2950 RETURN
2990 REM**SUBROUTINE TO VALIDATE DEUTERON WELL DEPTH**
3000 INPUT T4$
3010 PRINT CHR$(17);
3020 FOR I=1 TO 4:PRINT CHR$(19);:NEXT
3030 FOR I=1 TO 4:PRINT CHR$(26);:NEXT
3040 PRINT "                                               "
3050 IF VAL(T4$)<0 THEN 3110
3060 PRINT CHR$(17);
3070 FOR I=1 TO 4:PRINT CHR$(19);:NEXT
3080 FOR I=1 TO 4:PRINT CHR$(26);:NEXT
3090 PRINT "ENTER A NEGATIVE NUMBER";
3100 GOTO 3000
3110 RETURN
3190 REM**SUBROUTINE TO VALIDATE RECYCLING INPUT**
3200 INPUT T5$
3210 IF T5$="1" THEN 3280
3220 IF T5$="2" THEN 3280
3230 PRINT CHR$(12);
3240 PRINT:PRINT
3250 PRINT "NEW WELL DEPTH TYPE 1"
3260 PRINT "NEW ENERGY TYPE 2";
3270 GOTO 3200
3280 RETURN
3290 REM**SUBROUTINE TO VALIDATE ENERGY INPUT**
3300 INPUT T6$
3310 IF VAL(T6$)<0 THEN 3420
3320 IF VAL(T6$)>0 THEN 3420
3330 PRINT CHR$(17);
3340 FOR I=1 TO 4:PRINT CHR$(19);:NEXT
3350 FOR I=1 TO 5:PRINT CHR$(26);:NEXT
3360 PRINT "                                              "
3370 PRINT CHR$(17);
3380 FOR I=1 TO 4:PRINT CHR$(19);:NEXT
3390 FOR I=1 TO 5:PRINT CHR$(26);:NEXT
3400 PRINT "SELECT NEW ENERGY IN Mev";
3410 GOTO 3300
3420 RETURN
F A1=Y-4 THEN P1=140
4110 IF A1=Y-5 THEN P1=139
4120 IF A1=Y-6 THEN P1=138
4130 IF A1=Y-7 THEN P1=137
4140 POKE(-3617+(64*Y/